"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ramda = require("ramda");

var _mergeDeep = require("../mergeDeep");

var _mergeDeep2 = _interopRequireDefault(_mergeDeep);

var _nestedObjOf = require("../nestedObjOf");

var _nestedObjOf2 = _interopRequireDefault(_nestedObjOf);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = (0, _ramda.curryN)(3, function computedProp(computer, propOrPath, structure) {
  return (0, _mergeDeep2.default)(structure, (0, _nestedObjOf2.default)(propOrPath, computer(structure)));
}); // > ? Function -> (String | Array of Strings) -> Object:a -> Object:ab
//
// Given an object this function will return that object but with a new property, where the value is computed. The computation is given the object you'll be copying.
//
// ``` javascript
// import {computedProp} from "ramda-extra"
//
// const payload = {
//   id: "1",
//   attributes: {
//     username: "krainboltgreene"
//   }
// }
// const key = "tag"
// const computer = ({id, attributes: {username}}) => `${username}#${id}`
//
// computedProp(computer, key, payload)
// // {
// //   id: "1",
// //   tag: "krainboltgreene#1",
// //   attributes: {
// //     username: "krainboltgreene"
// //   }
// // }
//
// const multiKey = ["attributes", "tag"]
//
// computedProp(computer, key, payload)
// // {
// //   id: "1",
// //   attributes: {
// //     tag: "krainboltgreene#1",
// //     username: "krainboltgreene"
// //   }
// // }
// ```