"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ramda = require("ramda");

exports.default = (0, _ramda.curryN)(2, function hammer(key, structure) {
  if ((0, _ramda.type)(structure) !== "Object") {
    throw new Error("hammer only works on an Object, but the second argument was a " + (0, _ramda.type)(structure));
  }

  var onlyKey = (0, _ramda.prop)(key, structure);
  var withoutKey = (0, _ramda.omit)(key, structure);

  if ((0, _ramda.type)(onlyKey) !== "Object") {
    throw new Error("The hammered property " + key + " was not an Object it was a " + (0, _ramda.type)(onlyKey));
  }

  return (0, _ramda.merge)(withoutKey, onlyKey);
}); // > ? String -> Object:a -> Object:ab
//
// Use this to de-nest a nested object.
//
// ``` javascript
// import {hammer} from "ramda-extra"
//
// const payload = {
//   id: 1
//   attributes: {
//     name: "Kurtis Rainbolt-Greene",
//     age: 26
//   }
// }
//
// hammer("attributes", payload)
//
// // {
// //   id: 1,
// //   name: "Kurtis Rainbolt-Greene",
// //   age: 26
// // }
// ```