"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ramda = require("ramda");

// > ? (Object of Anything | Array of Anything):a -> (Object of Anything | Array of Anything):b
//
// Recursively merges two objects/arrays. THAT IS ALL.
//
// ``` javascript
// import {mergeDeep} from "ramda-extra"
//
// const left = {
//   alpha: "1"
// }
// const right = {
//   beta: "2"
// }
//
// mergeDeep(left, right)
// // {
// //   alpha: "1",
// //   beta: "2"
// // }
// ```
//
// ``` javascript
// import {mergeDeep} from "ramda-extra"
//
// const left = {
//   alpha: {
//     alpha1: "1"
//   }
// }
// const right = {
//   beta: {
//     beta1: "1"
//   }
// }
//
// mergeDeep(left, right)
// // {
// //   alpha: {
// //     alpha1: "1"
// //   },
// //   beta: {
// //     beta1: "1"
// //   }
// // }
// ```
//
// ``` javascript
// import {mergeDeep} from "ramda-extra"
//
// const left = {
//   alpha: [
//     "1"
//   ]
// }
// const right = {
//   alpha: [
//     "1"
//   ]
// }
//
// mergeDeep(left, right)
// // {
// //   alpha: [
// //     "1",
// //     "1"
// //   ]
// // }
// ```

var ARGUMENTS = 2;

exports.default = (0, _ramda.curryN)(ARGUMENTS, function mergeDeep(left, right) {
  if ((0, _ramda.type)(left) !== (0, _ramda.type)(right)) {
    return right;
  }

  if ((0, _ramda.type)(right) === "Object") {
    return (0, _ramda.mergeWith)(mergeDeep, left, right);
  }

  if ((0, _ramda.type)(right) === "Array") {
    return (0, _ramda.concat)(left, right);
  }

  return right;
});