"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ramda = require("ramda");

// > ? Array of Strings -> Anything -> Object
//
// Given a path and a value, it creates an object that has keys based on the path.
//
// ``` javascript
// import {nestedObjOf} from "ramda-extra"
//
// const path = ["key", "subkey"]
// const value = "value"
//
// nestedObjOf(path, value)
// // {
// //   key: {
// //     subkey: "value"
// //   }
// // }
// ```

exports.default = (0, _ramda.curryN)(2, function nestedObjOf(propOrPath, value) {
  if ((0, _ramda.isArrayLike)(propOrPath)) {
    return (0, _ramda.reduce)((0, _ramda.flip)(_ramda.objOf), value, (0, _ramda.reverse)(propOrPath));
  }

  return (0, _ramda.objOf)(propOrPath, value);
});