"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ramda = require("ramda");

var _shuffle = require("../shuffle");

var _shuffle2 = _interopRequireDefault(_shuffle);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = (0, _ramda.curryN)(2, function sample(size, list) {
  return (0, _ramda.take)(size, (0, _shuffle2.default)(list));
}); // > ? Integer:size -> Array of Anything:ab -> Array of Anything:b
//
// Takes an Array and randomly picks *Integer:size* elements to return.
//
//
// ``` javascript
// import {sample} from "ramda-extra"
// import {users} from "./users"
//
// console.log(users()) // => [{"id": 1, "name": "Kurtis Rainbolt-Greene"}, {"id": 2, "name": "Angela Englund"}]
//
// const game1Winner = sample(1, users())
// console.log(game1Winner) // => {"id": 2, "name": "Angela Englund"}
//
// const game2Winner = sample(1, users())
// console.log(game2Winner) // => {"id": 2, "name": "Angela Englund"}
//
// const game3Winner = sample(1, users())
// console.log(game3Winner) // => {"id": 1, "name": "Kurtis Rainbolt-Greene"}
// ```